LIBRARY ieee ;
USE ieee.std_logic_1164.all ;
LIBRARY ieee ;
use ieee.std_logic_unsigned.all;

entity DisplaySystem is

	port
		(
		--global
			Clock50 : in std_logic;  -- might get a faster ext clock later!
			clock27 : in std_logic;
			nReset : in std_logic;
		--vga
			H_Sync  : out std_logic;
			V_Sync : out std_logic;
			RedOut : out std_logic_vector(3 downto 0);
			GreenOut : out std_logic_vector(3 downto 0);
			BlueOut : out std_logic_vector(3 downto 0);
		
		-- system interface
			--interface from rest of system  {TBA}
				-- system interface
			--interface from rest of system  {TBA}
			SpecAmplitude : in std_logic_vector (7 downto 0);
			SpecStrobe : in  std_logic;  -- strobe the value in. might not be totally necessary
			SpecSweep : in  std_logic;  -- probably only as an overide, should be automatic?
			SpecReset : in  std_logic; -- as opposed to global, might use for pause/restart
	
		--Scope
			ScopeAmplitude : in std_logic;
			ScopeStrobe : in std_logic;  -- strobe the value in. might not be totally necessary
			ScopeSweep : in std_logic;  -- probably only as an overide, should be automatic?
			ScopeReset : in std_logic -- as opposed to global, might use for pause/restart
		);
	end DisplaySystem;
	
	
	
	
	architecture RTL of DisplaySystem is
	
signal	FreqBin : std_logic_vector (4 downto 0);
signal	TimeSlot :  std_logic_vector (7 downto 0);
signal	Power : std_logic_vector (7 downto 0);
signal	WritePower :  std_logic;
signal	Scroll :  std_logic;
signal	DisplayReady : std_logic;
	
	
	
	component Vgablock is
	
	port (
	Clock50 : in std_logic;  -- might get a faster ext clock later!
		clock27 : in std_logic;
		nReset : in std_logic;
	
		H_Sync  : out std_logic;
		V_Sync : out std_logic;
		RedOut : out std_logic_vector(3 downto 0);
		GreenOut : out std_logic_vector(3 downto 0);
		BlueOut : out std_logic_vector(3 downto 0);
		
		-- system interface
		--interface from rest of system  {TBA}
		SpecAmplitude : in std_logic_vector (7 downto 0);
		SpecStrobe : in  std_logic;  -- strobe the value in. might not be totally necessary
		SpecSweep : in  std_logic;  -- probably only as an overide, should be automatic?
		SpecReset : in  std_logic; -- as opposed to global, might use for pause/restart
	
	--Scope
			ScopeAmplitude : in std_logic;
			ScopeStrobe : in std_logic;  -- strobe the value in. might not be totally necessary
			ScopeSweep : in std_logic;  -- probably only as an overide, should be automatic?
			ScopeReset : in std_logic -- as opposed to global, might use for pause/restart
		
		);
	end component;
	
	
	begin
	
	vgablockinst : Vgablock
	port map
	(
			Clock50 => Clock50 ,
			clock27 => clock27 ,
			nReset => nReset,
		
			H_Sync  => H_Sync ,
			V_Sync => V_Sync,
			RedOut => RedOut,
			GreenOut =>GreenOut ,
			BlueOut => BlueOut,
		
			SpecAmplitude => SpecAmplitude,
			SpecStrobe => SpecStrobe,
			SpecSweep => SpecSweep,
			SpecReset => SpecReset,
			
			ScopeAmplitude => ScopeAmplitude ,
			ScopeStrobe => ScopeStrobe,  -- strobe the value in. might not be totally necessary
			ScopeSweep => ScopeSweep,  -- probably only as an overide, should be automatic?
			ScopeReset => ScopeReset -- a
	);
	
	
	
	
	end RTL;
	
	