
LIBRARY ieee ;
USE ieee.std_logic_1164.all ;
LIBRARY ieee ;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all; 

--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.numeric_std.all;
entity RootIteration is 

	port (
				Clock50 : in std_logic;  -- might get a faster ext clock later!
				nReset : in std_logic;	
				StrobeIn : in std_logic;
				SquareIn : in std_logic_vector (16 downto 0);
				IterateRootIn : in std_logic_vector (8 downto 0);  
				
				SetThatBit : out std_logic; -- inform that that bit being tested is to 
													 -- be set
				Finished : out std_logic; -- if at some point the iteration happens to
													-- be the root, then set this and everyone can 
													-- go home early
				StrobeOut : out std_logic -- inform is ready
			);
		
end RootIteration;


architecture RTL of RootIteration is

signal SquareReg : std_logic_vector (16 downto 0);
signal RootReg : std_logic_vector (8 downto 0);

signal SquareInt : integer range 0 to 131071; --  
signal RootInt : integer range 0 to 511; --  

signal IterateResult : integer range 0 to 131071;

signal CalcDelay : std_logic_vector (4 downto 0);

begin 

SquareInt <= to_integer(unsigned(SquareReg));
RootInt <= to_integer(unsigned(RootReg));
StrobeOut <= CalcDelay(3);
-----------------------------------------
-----------------------------------------
DataCapture : process (nReset,StrobeIn)
begin
	if (nReset = '0') then 
		SquareReg <= "00000000000000000";
		RootReg <= "000000000";
	elsif (rising_edge(StrobeIn)) then 
		SquareReg <= SquareIn;
		RootReg <= IterateRootIn;
	end if;
end process;
------------------------------------------
------------------------------------------
DelayAnswer : process (nReset,Clock50,StrobeIn)	
begin
		if ((nReset = '0') or ( StrobeIn = '1') )then 
			CalcDelay<="00000";
		elsif (rising_edge (Clock50) and (StrobeIn = '0')) then
				if (CalcDelay < "10000") then
					CalcDelay <= CalcDelay + 1;	
				end if;	
		end if;
end process;
---------------------------------------------
---------------------------------------------

---------------------------------------------
---------------------------------------------

Multiply : process (RootInt)
begin
		IterateResult <= RootInt*RootInt;
end process;
---------------------------------------------
---------------------------------------------
Compare : process (IterateResult)
begin
		if (IterateResult > SquareInt) then 
			SetThatBit <= '0';
			Finished <= '0';
		elsif (IterateResult = SquareInt) then
			SetThatBit <= '1';
			Finished <= '1';
		else
			SetThatBit <= '1';
			Finished <= '0';
		end if;
end process;
----------------------------------------------
----------------------------------------------

end RTL;