library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use std.textio.all;
entity SystemWrapper_tb is
end SystemWrapper_tb;

architecture tb of SystemWrapper_tb is
 
 
 constant Clock50_time_step : time := 1 ns;
  signal Clock50     : std_logic;
  signal Clock27 : std_logic;
  signal nReset : std_logic;
  
  
  signal SpecAmplitude  : std_logic_vector (7 downto 0);
  signal SpecStrobe : std_logic;  -- strobe the value in. might not be totally necessary
  signal	SpecSweep  :std_logic;  -- probably only as an overide, should be automatic?
  signal SpecReset  :std_logic; -- as opposed to global, might use for pause/restart
 
 signal ScopeAmplitude : std_logic;
 signal ScopeStrobe : std_logic;  -- strobe the value in. might not be totally necessary
 signal ScopeSweep : std_logic;  -- probably only as an overide, should be automatic?
 signal ScopeReset : std_logic; -- as opposed to global, might use for pause/restart
	
 signal Hold : std_logic;
  
--------------------------------------------------------------------------------------------                                      
-- ScopeEmulator
--------------------------------------------------------------------------------------------                                      
  component SystemWrapper is

	port
	(
		Clock50	: in std_logic;
		nReset : in std_logic;
		Hold : in std_logic;  -- a button that freezes system
		--NullData : in std_logic;
		-- currently just outputs stuff
		SpecAmplitude : out std_logic_vector (7 downto 0);
		SpecStrobe : out std_logic;  -- strobe the value in. might not be totally necessary
		SpecSweep : out std_logic;  -- probably only as an overide, should be automatic?
		SpecReset : out std_logic; -- as opposed to global, might use for pause/restart
	
		ScopeAmplitude : out std_logic;
		ScopeStrobe : out std_logic;  -- strobe the value in. might not be totally necessary
		ScopeSweep : out std_logic;  -- probably only as an overide, should be automatic?
		ScopeReset : out std_logic -- as opposed to global, might use for pause/restart
	);

  end component;
  
 -----------------------------------------------------------------
-------------------------------------------------------------------


 
  
  
begin
  -----------------------------------------------------------------------------------------------
  -- nReset Generation                                                                          
  -----------------------------------------------------------------------------------------------
  nReset <= '0',
             '1' after 92*Clock50_time_step;
				 
				 
	
  -----------------------------------------------------------------------------------------------
  -- Clock Generation                                                                         
  -----------------------------------------------------------------------------------------------
  Clock50gen : process
  begin
   
      Clock50 <= '0';
      wait for 5*Clock50_time_step;
      Clock50 <= '1';
      wait for 5*Clock50_time_step;
   
  end process Clock50gen;

  Clock27gen : process
  begin
		Clock27 <= '0';
      wait for 9*Clock50_time_step;
      Clock27 <= '1';
      wait for 8*Clock50_time_step;
   
  end process Clock27gen;


  
  
  
  


 SystemWrapperInst : SystemWrapper
 
 port map
 (
		Clock50	=> Clock50,
		nReset 	=> nReset,
		Hold => Hold,
	
		SpecAmplitude =>SpecAmplitude,
		SpecStrobe =>SpecStrobe,  -- strobe the value in. might not be totally necessary
		SpecSweep =>SpecSweep,  -- probably only as an overide, should be automatic?
		SpecReset => SpecReset,-- as opposed to global, might us
		
		ScopeAmplitude =>ScopeAmplitude,
		ScopeStrobe => ScopeStrobe, -- strobe the value in. might not be totally necessary
		ScopeSweep => ScopeSweep, -- probably only as an overide, should be automatic?
		ScopeReset => ScopeReset-- as opposed to global, might use for pause/restart
	
 );
  
end tb;
