library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
entity window is 

	port (
	
				Clock50 : in std_logic;  -- might get a faster ext clock later!
				nReset : in std_logic;	
				Clock4K : in std_logic;  --sample clock	
				Buffered_ECG	: IN STD_LOGIC_VECTOR (7 DOWNTO 0); -- 
				sink_eop : in std_logic; -- informing FFT is end of packet, and here to reset window index
			
				Windowed_ECG : out std_logic_vector (7 downto 0)  -- the data after window applied
		
			);
		
end window;


architecture RTL of window is



begin 

-----------------------------------------
-- Data clocked in and out on rising edge of
-- Clock4K, OUTSDIDE of the state machine
-------------------------------------------
init : process (nReset,Clock4K)
	begin
		if (nReset ='0') then 
			TheInput <= 0;
			Windowed_ECG  <="00000000";
			TableIndex <= 0;
	   elsif (rising_edge (Clock4K))  then
			TheInput <= to_integer(signed(Buffered_ECG));
			Windowed_ECG <= interimresult(17 downto 10);
			--resultlv <= std_logic_vector(to_signed(result,22));
				if (sink_eop = '1') then
					TableIndex <= 0;
				else 
					TableIndex <= TableIndex+1;
				end if;
					if TableIndex>63 then
						TableIndex<=0;
					end if;
			end if;
	end process;
	
DoWindow:process (nReset,Clock4K)
begin
	if (falling_edge (Clock4K)) then
		result <= TheInput*HannTable(TableIndex);
		
	end if;
	
end process;

interimresult <= std_logic_vector(to_signed(result,18));

----------------------------------------------------------
--- Look Up Table for Hann Function ----
------------------------------------------	
HannTable(	0	)<=	0	;
HannTable(	1	)<=	2	;
HannTable(	2	)<=	10	;
HannTable(	3	)<=	22	;
HannTable(	4	)<=	40	;
HannTable(	5	)<=	62	;
HannTable(	6	)<=	88	;
HannTable(	7	)<=	119	;
HannTable(	8	)<=	154	;
HannTable(	9	)<=	192	;
HannTable(	10	)<=	234	;
HannTable(	11	)<=	278	;
HannTable(	12	)<=	324	;
HannTable(	13	)<=	373	;
HannTable(	14	)<=	423	;
HannTable(	15	)<=	473	;
HannTable(	16	)<=	524	;
HannTable(	17	)<=	575	;
HannTable(	18	)<=	625	;
HannTable(	19	)<=	675	;
HannTable(	20	)<=	722	;
HannTable(	21	)<=	768	;
HannTable(	22	)<=	810	;
HannTable(	23	)<=	850	;
HannTable(	24	)<=	887	;
HannTable(	25	)<=	920	;
HannTable(	26	)<=	948	;
HannTable(	27	)<=	973	;
HannTable(	28	)<=	993	;
HannTable(	29	)<=	1008	;
HannTable(	30	)<=	1018	;
HannTable(	31	)<=	1023	;
HannTable(	32	)<=	1023	;
HannTable(	33	)<=	1018	;
HannTable(	34	)<=	1008	;
HannTable(	35	)<=	993	;
HannTable(	36	)<=	973	;
HannTable(	37	)<=	948	;
HannTable(	38	)<=	920	;
HannTable(	39	)<=	887	;
HannTable(	40	)<=	850	;
HannTable(	41	)<=	810	;
HannTable(	42	)<=	768	;
HannTable(	43	)<=	722	;
HannTable(	44	)<=	675	;
HannTable(	45	)<=	625	;
HannTable(	46	)<=	575	;
HannTable(	47	)<=	524	;
HannTable(	48	)<=	473	;
HannTable(	49	)<=	423	;
HannTable(	50	)<=	373	;
HannTable(	51	)<=	324	;
HannTable(	52	)<=	278	;
HannTable(	53	)<=	234	;
HannTable(	54	)<=	192	;
HannTable(	55	)<=	154	;
HannTable(	56	)<=	119	;
HannTable(	57	)<=	88	;
HannTable(	58	)<=	62	;
HannTable(	59	)<=	40	;
HannTable(	60	)<=	22	;
HannTable(	61	)<=	10	;
HannTable(	62	)<=	2	;
HannTable(	63	)<=	0	;
HannTable(	64	)<=	0	;

end RTL;